const fs = require('fs');
const path = require('path');
const compile = require('./compiler');
const parse = require('./parser');

module.exports = opts => {
  const main = fs.readFileSync(opts.entryPoint).toString();
  const contents = opts.files.map(file => fs.readFileSync(file).toString());

  const sassOptions = opts.sassOptions || {};
  const includePaths = sassOptions.includePaths || [];

  const options = Object.assign({}, opts.sassOptions, {
    includePaths: [path.dirname(opts.entryPoint)].concat(includePaths)
  });

  return compile(main, parse(contents), options);
};